<?php

/* * **************************************************************************************\
 * *   @name		EXP Autos  2.0                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2011  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

//no direct access
defined('_JEXEC') or die;

require_once JPATH_ROOT . '/components/com_expautospro/helpers/expparams.php';

class ModExpautosChart {

    public static function expcurrentChartText() {
        $postexpid = JRequest::getInt('id');
        $return_val = null;
        if ($postexpid) {
            $db = JFactory::getDBO(true);
            $query = $db->getQuery(true);
            $query->select('a.year');
            $query->from('#__expautos_admanager as a');

            $query->select('c.title AS category_name, c.id AS categid');
            $query->join('LEFT', '#__categories AS c ON c.id = a.catid');

            /* Makes */
            $query->select('mk.name AS make_name');
            $query->join('LEFT', '#__expautos_make AS mk ON mk.id = a.make');

            /* Models */
            $query->select('md.name AS model_name');
            $query->join('LEFT', '#__expautos_model AS md ON md.id = a.model');

            $query->where('a.id = ' . (int) $postexpid);

            $db->setQuery($query);
            $return = $db->loadObject();
            if ($return) {
                $return_val = $return->category_name . " " . $return->make_name . " " . $return->model_name . " " . $return->year;
            }
        }
        return $return_val;
    }

    public static function expcurrentChart() {
        $postexpid = JRequest::getInt('id');
        $return_val = null;
        if ($postexpid) {
            $db = JFactory::getDBO(true);
            //$db->setQuery('SELECT a.mileage,IF( a.bprice != "",a.bprice,a.price ) price FROM #__expautos_admanager AS a WHERE a.id='.(int)$postexpid);
            $query = $db->getQuery(true);
            $query->select('a.id,a.mileage,IF( a.bprice != "",a.bprice,a.price ) price, a.imgmain AS img_name');
            $query->from('#__expautos_admanager as a');

            $query->select('bt.id AS btid,bt.name AS bodytype_name');
            $query->join('LEFT', '#__expautos_bodytype AS bt ON bt.id = a.bodytype');
            /* Transmission */
            $query->select('tr.id AS trid,tr.name AS trans_name');
            $query->join('LEFT', '#__expautos_trans AS tr ON tr.id = a.trans');
            /* old version 3.5.1
              $query->select('img.name AS img_name');
              $query->join('LEFT', '#__expautos_images AS img ON a.id = img.catid AND img.ordering = 1');
             */

            $query->where('a.id = ' . (int) $postexpid);

            $db->setQuery($query);
            $return = $db->loadObject();
            //$link = JRoute::_('index.php?option=com_expautospro&amp;view=expdetail&amp;id=' . (int) $return->id . '&amp;Itemid=' . (int) $itemid);
            if ($return) {
                if ($return->img_name) {
                    $img_file = '<img src="' . ExpAutosProExpparams::ImgUrlPatchThumbs() . $return->img_name . '" />';
                } else {
                    $img_file = '<img src="' . ExpAutosProExpparams::ImgUrlPatch() . 'assets/images/no_photo.jpg" />';
                }
                $return_val = "[" . $return->mileage . "," . $return->price . ",'" . $return->bodytype_name . "','" . $return->trans_name . "','" . $img_file . "',null]";
            }
        }
        return $return_val;
    }

    public static function expCharts() {
        $postexpid = JRequest::getInt('id');
        $return_val = null;
        if ($postexpid) {
            $db = JFactory::getDBO(true);
            $db->setQuery('SELECT catid,make,model,year FROM #__expautos_admanager WHERE id=' . (int) $postexpid);
            $current_ad = $db->loadObject();
            if ($current_ad) {
                $query = $db->getQuery(true);
                $query->select('a.id,a.mileage,a.year,a.catid,IF( a.bprice != "",a.bprice,a.price ) price, a.imgmain AS img_name');
                $query->from('#__expautos_admanager as a');

                $query->select('bt.id AS btid,bt.name AS bodytype_name');
                $query->join('LEFT', '#__expautos_bodytype AS bt ON bt.id = a.bodytype');
                /* Transmission */
                $query->select('tr.id AS trid,tr.name AS trans_name');
                $query->join('LEFT', '#__expautos_trans AS tr ON tr.id = a.trans');
                /* old version 3.5.1
                  $query->select('img.name AS img_name');
                  $query->join('LEFT', '#__expautos_images AS img ON a.id = img.catid AND img.ordering = 1');
                 */

                $query->where('a.year = ' . (int) $current_ad->year);
                $query->where('a.catid = ' . (int) $current_ad->catid);
                $query->where('a.make = ' . (int) $current_ad->make);
                $query->where('a.model = ' . (int) $current_ad->model);
                $query->where('a.id != ' . (int) $postexpid);
                $query->where('a.year > 0');
                $query->where('a.mileage > 0');
                $query->where('a.price > 0');
                $query->where('a.state = 1');
                $db->setQuery($query);
                $listall = $db->loadObjectList();
                if ($listall) {
                    foreach ($listall as $val) {
                        $link = JRoute::_('index.php?option=com_expautospro&amp;view=expdetail&amp;catid=' . (int) $val->catid . '&amp;id=' . (int) $val->id . '&amp;Itemid=' . ModExpautosChart::getItemid());
                        if ($val->img_name) {
                            $img_file = '<img src="' . ExpAutosProExpparams::ImgUrlPatchThumbs() . $val->img_name . '" />';
                        } else {
                            $img_file = '<img src="' . ExpAutosProExpparams::ImgUrlPatch() . 'assets/images/no_photo.jpg" />';
                        }
                        $return[] = "[" . $val->mileage . "," . $val->price . ",'" . $val->bodytype_name . "','" . $val->trans_name . "','" . $img_file . "','" . $link . "']";
                    }
                    $return_val = implode(",", $return);
                }
            }
        }
        return $return_val;
    }

    public static function getItemid() {
        $expitemid = ExpAutosProExpparams::getExpLinkItemid();
        return $expitemid;
    }

}
?>

