<?php

/****************************************************************************************\
 **   @name		EXP Autos  2.0                                                  **
 **   @package          Joomla 1.6                                                      **
 **   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 **   @copyright	Copyright (C) 2005 - 2011  EXP TEAM::Alexey Kurguz (Grusha)     **
 **   @link             http://www.feellove.eu                                          **
 **   @license		Commercial License                                              **
 \****************************************************************************************/

//no direct access
defined('_JEXEC') or die;

require_once JPATH_ROOT . '/components/com_expautospro/helpers/expparams.php';
require_once JPATH_ROOT . '/components/com_expautospro/helpers/expfields.php';

class ModExpautosListFilter {
    
    public static function explistfilter(){
        
    }
    
    public static function getItemid() {
        $expitemid = ExpAutosProExpparams::getExpLinkItemid();
        return $expitemid;
    }
    
    public static function getCategory($module_id,$params) {
        $options = array();
        $catid = (int) JRequest::getInt('catid', 0);
        $val_id = 0;
        if($catid){
            $val_id = $catid;
        }
        $options = ExpAutosProExpparams::getExpCategories($params->get('allowedcat'),$params->get('showcount',1));
        $onchange =' class="chzn-explsfselect" onchange="';
        
        if ($params->get('usemakes'))
            $onchange .='expselectval(this,\'makeid'.$module_id.'\');';
        if ($params->get('usemodels'))
            $onchange .='expselectval(this,\'modelid'.$module_id.'\');';
        if ($params->get('usebodytype'))
            $onchange .='expselectval(this,\'bodytype'.$module_id.'\');';
        if ($params->get('useextrafield1'))
            $onchange .='expselectval(this,\'extrafield1'.$module_id.'\');';
        
        $onchange .=' this.form.submit();"';
        if (!isset($data)) {
            $return = JHtml::_('select.genericlist', $options, 'catid', $onchange, 'value', 'text', $val_id, 'catid'.$module_id);
        }

        return $return;
    }
    
    public static function getMake($module_id,$params) {
        $options = array();
        $catid = '';
        $show_catid = $params->get('defcat');
        if ($show_catid) {
            $catid = $show_catid;
        } else {
            $catid = (int) JRequest::getInt('catid', 0);
        }
        $val_id = 0;
        if($catid){
            $makeid = (int) JRequest::getInt('makeid', 0);
            if ($makeid) {
                $val_id = $makeid;
            }
            $json_make = ExpAutosProFields::getExpSelect($catid, 'make', 'name', 'catid', '', 'ordering','',$params->get('showcount',1));
            $json_make = json_decode($json_make);
            //print_r($json_make);
            if($json_make){
                foreach ($json_make as $value) {
                    if($value->value > 0){
                        $options[] = JHTML::_('select.option', $value->value, $value->text);
                    }
                }
            }
        }
        $expdisable = null;
        if(empty($options)){
            $expdisable = ' disabled ';
        }
        $onchange = $expdisable.' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_MAKES_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'makeid', $onchange, 'value', 'text', $val_id, 'makeid'.$module_id);
        }

        return $return;
    }
    
    public static function getModel($module_id,$params) {
        $options = array();
        $expparams = ExpAutosProExpparams::getExpParams('config', 1);
        $multi_models = $expparams->get('c_admanager_mdpage_multi',0);
        $makeid = (int) JRequest::getInt('makeid', 0);
        $val_id = 0;
        if($makeid){
            if($multi_models){
                $modelid = JRequest::getVar('modelid', array(), 'get', 'array');
            }else{
                $modelid = (int) JRequest::getInt('modelid', 0);
            }
            if ($modelid) {
                $val_id = $modelid;
            }
            $json_model = ExpAutosProFields::getExpSelect($makeid, 'model', 'name', 'makeid', '', 'name','',$params->get('showcount',1));
            $json_model = json_decode($json_model);
            //print_r($json_make);
            if($json_model){
                foreach ($json_model as $value) {
                    if($value->value > 0){
                        $options[] = JHTML::_('select.option', $value->value, $value->text);
                    }
                }
            }
        }
        $expdisable = null;
        if(empty($options)){
            $expdisable = ' disabled ';
        }
        $val_multi = null;
        $val_modelid = 'modelid';
        if($multi_models){
            $val_multi = ' multiple  data-placeholder="'.JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_PLACEHOLDER_MULTI_TEXT').'" ';
            $val_modelid = 'modelid[]';
        }
        $onchange = $val_multi.$expdisable.' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_MODELS_TEXT')));
            $return = JHtml::_('select.genericlist', $options, $val_modelid, $onchange, 'value', 'text', $val_id, 'modelid'.$module_id);
        }
        return $return;
    }
    
    public static function getCondition($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $conditionid = (int) JRequest::getInt('condition', '-2');
        if($conditionid >= 0){
            $setcondition = (int)$app->setUserState('expcondition',$conditionid);
        }
        $val_id = (int) $app->getUserState('expcondition');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_condition');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_CONDITION_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'condition', $onchange, 'value', 'text', $val_id, 'condition'.$module_id);
        }

        return $return;
    }
    
    public static function getBodytype($module_id,$params) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $catid = '';
        $show_catid = $params->get('defcat');
        if ($show_catid) {
            $catid = $show_catid;
        } else {
            $catid = (int) JRequest::getInt('catid', 0);
        }
        if($catid){
            $bodytypeid = (int) JRequest::getInt('bodytype', -2);
            if($bodytypeid >= 0){
                $setbodytype = (int)$app->setUserState('expbodytype',$bodytypeid);
            }
            $val_id = (int) $app->getUserState('expbodytype');
            $json_btype = ExpAutosProFields::getExpSelect($catid, 'bodytype', 'name', 'catid', '', 'ordering','',0);
            $json_btype = json_decode($json_btype);
            //print_r($json_make);
            if($json_btype){
                foreach ($json_btype as $value) {
                    if($value->value > 0){
                        $options[] = JHTML::_('select.option', $value->value, $value->text);
                    }
                }
            }
        }
        $expdisable = null;
        if(empty($options)){
            $expdisable = ' disabled ';
        }
        $onchange = $expdisable.' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_BODYTYPE_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'bodytype', $onchange, 'value', 'text', $val_id, 'bodytype'.$module_id);
        }

        return $return;
    }
    
    public static function getExtrafield1($module_id,$params) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $catid = '';
        $show_catid = $params->get('defcat');
        if ($show_catid) {
            $catid = $show_catid;
        } else {
            $catid = (int) JRequest::getInt('catid', 0);
        }
        if($catid){
            $extrafield1id = (int) JRequest::getInt('extrafield1', -2);
            if($extrafield1id >= 0){
                $setextrafield1 = (int)$app->setUserState('extrafield1',$extrafield1id);
            }
            $val_id = (int) $app->getUserState('extrafield1');
            $json_extrafield1 = ExpAutosProFields::getExpSelect($catid, 'extrafield1', 'name', 'catid', '', 'name','',0);
            $json_extrafield1 = json_decode($json_extrafield1);
            //print_r($json_make);
            if($json_extrafield1){
                foreach ($json_extrafield1 as $value) {
                    if($value->value > 0){
                        $options[] = JHTML::_('select.option', $value->value, $value->text);
                    }
                }
            }
        }
        $expdisable = null;
        if(empty($options)){
            $expdisable = ' disabled ';
        }
        $onchange = $expdisable.' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_EXTRAFIELD1_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'extrafield1', $onchange, 'value', 'text', $val_id, 'extrafield1'.$module_id);
        }

        return $return;
    }
    
    public static function getExtrafield2($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $extrafield2id = (int) JRequest::getInt('extrafield2', '-2');
        if($extrafield2id >= 0){
            $setextrafield2 = (int)$app->setUserState('expextrafield2',$extrafield2id);
        }
        $val_id = (int) $app->getUserState('expextrafield2');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_extrafield2');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_EXTRAFIELD2_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'extrafield2', $onchange, 'value', 'text', $val_id, 'extrafield2'.$module_id);
        }

        return $return;
    }
    
    public static function getExtrafield3($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $extrafield3id = (int) JRequest::getInt('extrafield3', '-2');
        if($extrafield3id >= 0){
            $setextrafield3 = (int)$app->setUserState('expextrafield3',$extrafield3id);
        }
        $val_id = (int) $app->getUserState('expextrafield3');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_extrafield3');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_EXTRAFIELD3_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'extrafield3', $onchange, 'value', 'text', $val_id, 'extrafield3'.$module_id);
        }

        return $return;
    }
    
    public static function getYearFrom($module_id) {
        $expreqfield = ExpAutosProExpparams::getExpParams('config',1);
        $minyear = $expreqfield->get('c_admanager_minyear');
        $app = JFactory::getApplication();
        $yearfromid = (int) JRequest::getInt('yearfrom', '-2');
        if($yearfromid >= 0){
            $setyearfrom = (int)$app->setUserState('expyearfrom',$yearfromid);
        }
        $val_id = (int) $app->getUserState('expyearfrom');
        if (!isset($data)) {
            $options[] = JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_TEXT'));
            for($i = date("Y") + 1; $i >= $minyear; $i--){
                $options[] = JHTML::_('select.option', $i, $i);
            }
            $attr = ' class="modexpsearch_year chzn-explsfselect"';
            $attr .= ' onchange="this.form.submit();"';
            $return = JHtml::_('select.genericlist', $options, 'yearfrom', $attr, 'value', 'text', $val_id, 'yearfrom'.$module_id);
        }

        return $return;
    }
    
    public static function getYearTo($module_id) {
        $expreqfield = ExpAutosProExpparams::getExpParams('config',1);
        $minyear = $expreqfield->get('c_admanager_minyear');
        $app = JFactory::getApplication();
        $yeartoid = (int) JRequest::getInt('yearto', '-2');
        if($yeartoid >= 0){
            $setyearto = (int)$app->setUserState('expyearto',$yeartoid);
        }
        $val_id = (int) $app->getUserState('expyearto');
        if (!isset($data)) {
            $options[] = JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_TEXT'));
            for($i = date("Y") + 1; $i >= $minyear; $i--){
                $options[] = JHTML::_('select.option', $i, $i);
            }
            $attr = ' class="modexpsearch_year chzn-explsfselect"';
            $attr .= ' onchange="this.form.submit();"';
            $return = JHtml::_('select.genericlist', $options, 'yearto', $attr, 'value', 'text', $val_id, 'yearto'.$module_id);
        }

        return $return;
    }
    
    public static function getFuel($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $fuelid = (int) JRequest::getInt('fuel', '-2');
        if($fuelid >= 0){
            $setfuel = (int)$app->setUserState('expfuel',$fuelid);
        }
        $val_id = (int) $app->getUserState('expfuel');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_fuel');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_FORM_FUEL_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'fuel', $onchange, 'value', 'text', $val_id, 'fuel'.$module_id);
        }

        return $return;
    }
    
    public static function getDrive($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $driveid = (int) JRequest::getInt('drive', '-2');
        if($driveid >= 0){
            $setdrive = (int)$app->setUserState('expdrive',$driveid);
        }
        $val_id = (int) $app->getUserState('expdrive');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_drive');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_FORM_DRIVE_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'drive', $onchange, 'value', 'text', $val_id, 'drive'.$module_id);
        }

        return $return;
    }
    
    public static function getTrans($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $transid = (int) JRequest::getInt('trans', '-2');
        if($transid >= 0){
            $settrans = (int)$app->setUserState('exptrans',$transid);
        }
        $val_id = (int) $app->getUserState('exptrans');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_trans');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_FORM_TRANSMISSION_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'trans', $onchange, 'value', 'text', $val_id, 'trans'.$module_id);
        }

        return $return;
    }
    
    public static function getCountry($module_id,$params) {
        $options = array();
        $app = JFactory::getApplication();
        $countryid = (int) JRequest::getInt('country', '-2');
        if($countryid >= 0){
            $setcountry = (int)$app->setUserState('expcountry',$countryid);
        }
        $val_id = (int) $app->getUserState('expcountry');
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_country');
        $query->where('state = 1');
        $query->order('name');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_COUNTRY_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'country', $onchange, 'value', 'text', $val_id, 'country'.$module_id);
        }

        return $return;
    }
    
    public static function getExpState($module_id,$params) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $setcountry = (int)$app->getUserState('expcountry');
        if($setcountry){
            $expstateid = (int) JRequest::getInt('expstate', '-2');
            if($expstateid >= 0){
                $setexpstate = (int)$app->setUserState('expstateval',$expstateid);
            }
            $val_id = (int) $app->getUserState('expstateval');
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id As value, name As text');
            $query->from('#__expautos_state');
            $query->where('state = 1');
            $query->where('catid = '.$setcountry);
            $query->order('name');

            // Get the options.
            $db->setQuery($query);

            $options = $db->loadObjectList();

            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_STATE_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'expstate', $onchange, 'value', 'text', $val_id, 'expstate'.$module_id);
        }

        return $return;
    }
    
    public static function getCity($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $val_id = 0;
        $setexpstate = (int)$app->getUserState('expstateval');
        if($setexpstate){
            $expcityid = (int) JRequest::getInt('city', '-2');
            if($expcityid >= 0){
                $setexpcity = (int)$app->setUserState('expcity',$expcityid);
            }
            $val_id = (int) $app->getUserState('expcity');
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id As value, city_name As text');
            $query->from('#__expautos_cities');
            $query->where('state = 1');
            $query->where('catid = '.$setexpstate);
            $query->order('city_name');

            // Get the options.
            $db->setQuery($query);

            $options = $db->loadObjectList();

            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_CITY_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'city', $onchange, 'value', 'text', $val_id, 'city'.$module_id);
        }
        return $return;
    }
    
    public static function getDealer($module_id) {
        $options = array();
        $sortfield = "us.username";
        $app = JFactory::getApplication();
        $val_id = 0;
        /*
        $expuserid = (int) JRequest::getInt('userid', 0);
        if($expuserid){
            $val_id = $expuserid;
        }
         */

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('a.userid As value, '.$sortfield.' As text');
        $query->from('#__expautos_expuser AS a');
        $query->join('LEFT', '#__users AS us ON us.id = a.userid');
        $query->where('a.state = 1');
        $query->where('us.block = 0');
        $query->order($sortfield);

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_FORM_USER_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'userid', $onchange, 'value', 'text', $val_id, 'userid'.$module_id);
        }

        return $return;
    }

    public static function getAgeof($module_id) {
        $app = JFactory::getApplication();
        $ageofid = (int) JRequest::getInt('ageof', '-2');
        if($ageofid >= 0){
            $setageof = (int)$app->setUserState('expageof',$ageofid);
        }
        $val_id = (int) $app->getUserState('expageof');
        $ageof[] = JHTML::_('select.option', '', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_AGEOF_ALL_TEXT'));
        $ageof[] = JHTML::_('select.option', '1', JText::_(JText::sprintf('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_AGEOF_DAY_TEXT',1)));
        $ageof[] = JHTML::_('select.option', '3', JText::_(JText::sprintf('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_AGEOF_DAYS_TEXT',3)));
        $ageof[] = JHTML::_('select.option', '7', JText::_(JText::sprintf('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_AGEOF_DAYS_TEXT',7)));
        $ageof[] = JHTML::_('select.option', '14', JText::_(JText::sprintf('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_AGEOF_DAYS_TEXT',14)));
        
        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        $return = JHTML::_('select.genericlist', $ageof, 'ageof', $onchange, 'value', 'text', $val_id, 'ageof'.$module_id);
        return $return;;
    }

    public static function expsortBy($module_id) {
        $val_id = 0;
        /*
        $app = JFactory::getApplication();
        $sortbyid = (int) JRequest::getInt('sortby', '-2');
        if($sortbyid >= 0){
            $setsortby = (int)$app->setUserState('expsortby',$sortbyid);
        }
        $val_id = (int) $app->getUserState('expsortby');
        */
        $expsortby[] = JHTML::_('select.option', '', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_TEXT'));
        $expsortby[] = JHTML::_('select.option', 'make_name', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_SORTBY_MAKES_TEXT'));
        $expsortby[] = JHTML::_('select.option', 'model_name', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_SORTBY_MODELS_TEXT'));
        $expsortby[] = JHTML::_('select.option', 'price', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_SORTBY_PRICE_TEXT'));
        $expsortby[] = JHTML::_('select.option', 'a.year', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_SORTBY_YEAR_TEXT'));

        $onchange =' class="chzn-explsfselect" onchange="this.form.submit();"';
        $return = JHTML::_('select.genericlist', $expsortby, 'filter_order', $onchange, 'value', 'text', $val_id, 'sortby'.$module_id);
        return $return;;
    }

    public static function getColor($module_id) {
        $options = array();
        $app = JFactory::getApplication();
        $extrafield3id = (int) JRequest::getInt('color', '-2');
        if ($extrafield3id >= 0) {
            $setextrafield3 = (int) $app->setUserState('expcolor', $extrafield3id);
        }
        $val_id = (int) $app->getUserState('expcolor');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id As value, name As text');
        $query->from('#__expautos_color');
        $query->where('state = 1');
        $query->order('ordering');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $onchange = ' class="span2 chzn-explsfselect" ';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_SEARCH_LISTFILTER_SELECT_COLOR_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'color', $onchange, 'value', 'text', $val_id, 'color' . $module_id);
        }

        return $return;
    }

}
?>

